#ifndef _TRAPAGENTC_H
#define _TRAPAGENTC_H

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const TrapAgentC_hxx_Version =
    "$Id: TrapAgentC.hxx,v 1.13 2001/10/19 20:46:54 icahoon Exp $";

#include "TrapAgent.hxx"
#include "ServerTable.hxx"

#ifdef __cplusplus
extern "C"
{
#endif
    extern void *trapAgent;

    /**
     * this is a wrapper around the trapAgent class.
     * it is used by the 'c' software
     */

    /// See TrapAgent::TrapAgent
    void *
    TrapAgent_create1();

    /// See TrapAgent::TrapAgent::free
    void
    TrapAgent_free(void *objPtr);

    /**
     * this provides a 'c' wraper around TrapAgent::run
     */
    void
    TrapAgent_run(void *objPtr);

    /**
     * this provides a 'c' wraper around TrapAgent::GetApplicationList
     */
    void *
    TrapAgent_GetApplicationList(void *objPtr);

    /**
     * this provides a 'c' wraper around TrapAgent::GetApplication
     */
    applInfoT
    TrapAgent_GetApplication(void *objPtr, int index);

    /**
     * this provides a 'c' wraper around TrapAgent::GetStackPortFromIndex
     */
    int
    TrapAgent_GetStackPortFromIndex(void *objPtr, int index);

    /**
     * this provides a 'c' wraper around TrapAgent::GetApplPortFromIndex
     */
    int
    TrapAgent_GetApplPortFromIndex(void *objPtr, int index);

    /**
     * this provides a 'c' wraper around TrapAgent::GetNumberOfAppl
     */
    int
    TrapAgent_GetNumOfApps(void *objPtr);

    /**
     * this provides a 'c' wraper around TrapAgent::GetNextIndex
     */
    int
    TrapAgent_GetNextIndex(void *objPtr, int index, enum ServerType type);

    ///  The following functions are for the server cache (serverTable class)
    serverInfoT 
    TrapAgent_GetServerFromIndex(void *objPtr, unsigned long index);

    unsigned long 
    TrapAgent_GetNextServerIndex(void *objPtr, unsigned long index);

    void
    TrapAgent_ClearServerCache(void *objPtr);

    void
    TrapAgent_InsertServer(void *objPtr, serverInfoT aServer);
    

#ifdef __cplusplus
} /*close extern C*/
#endif

#endif /* _TRAPAGNETC_H */
