#ifndef AGENT_TRAP_H
#define AGENT_TRAP_H

#ifdef __cplusplus
extern "C" {
#endif

//vovida added:  
// returns the total number of trap
// sinks currently in the system
int totalTrapSinks();
// returns true on success false on failure.
// sets a list of trap sinks.  The sinks are
// represented by ulong ip in network byte order.  The
// function will return the first listSize of them.  The user is responsible
// for providing enough space in trapList for listSize elements (ulong or 4 bytes)
int trapSinkList(unsigned long *trapList, int listSize);
// delete all instances of a single ip trap destination.
// returns 0 if no elements were deleted
int remove_v2_trap_sink (unsigned long ip);
//  adds a single entry (ip) into the trap sinks list
//  returns 0 if no elements were added
int add_v2_trap_sink (unsigned long ip);
// end vovida

void send_easy_trap (int, int);
void send_trap_pdu(struct snmp_pdu *);
void send_v2trap ( struct variable_list *);
void send_trap_vars (int, int, struct variable_list *);
void send_enterprise_trap_vars (int trap, 
		     int specific,
		     oid *enterprise, int enterprise_length,
		     struct variable_list *vars);

void snmpd_parse_config_authtrap (const char *, char *);
void snmpd_parse_config_trapsink (const char *, char *);
void snmpd_parse_config_trap2sink (const char *, char *);
void snmpd_parse_config_informsink (const char *, char *);
void snmpd_free_trapsinks (void);
void snmpd_parse_config_trapcommunity (const char *, char *);
void snmpd_free_trapcommunity (void);

int create_trap_session (char *, u_short *, char *, int, int);
int add_trap_session( struct snmp_session *, int, int);

#ifdef __cplusplus
};
#endif

#endif /* AGENT_TRAP_H */
