#if !defined(H323_SIP_OP_REGISTER_IN_DOT_H)
#define H323_SIP_OP_REGISTER_IN_DOT_H

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */


static const char* const H323SipOpRegisterIn_hxx_Version = 
    "$Id: H323SipOpRegisterIn.hxx,v 1.8 2001/02/13 05:29:15 icahoon Exp $";


#include "H323SipOpIn.hxx"


/** Vovida Open Communication Application Library<br><br>
 */
namespace Vocal
{


/** Sip to H.323 Proxy<br><br>
 */
namespace SipH323Proxy
{


/** Operator to handle incoming REGISTER messages.<br><br>
 *
 *  @see    Vocal::SipH323Proxy::H323SipOpIn
 */
class H323SipOpRegisterIn : public Vocal::SipH323Proxy::H323SipOpIn
{

    public:


    	/** Create given the sip proxy configuration information.
	 */
    	H323SipOpRegisterIn(SipProxyInfo &);


    	/** Virtual destructor
	 */
    	virtual     ~H323SipOpRegisterIn();


    	/** Name of the class of event being "H323SipOpRegisterIn".
	 */
    	virtual const	char* const 	name() const;


    	/** Operator callback. It sends back 403, function not supported.
	 */
    	virtual const Sptr<State> process(const Sptr<SipProxyEvent> event);
};


} // namespace SipH323Proxy
} // namespace Vocal


#endif // H323_SIP_OP_REGISTER_IN_DOT_H
