#!/bin/bash
#
# $Id: make_call_trace.cgi,v 1.1 2000/12/05 22:01:32 icahoon Exp $
#
# ====================================================================
# The Vovida Software License, Version 1.0 
# 
# Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. The names "VOCAL", "Vovida Open Communication Application Library",
#    and "Vovida Open Communication Application Library (VOCAL)" must
#    not be used to endorse or promote products derived from this
#    software without prior written permission. For written
#    permission, please contact vocal\@vovida.org.
# 
# 4. Products derived from this software may not be called "VOCAL", nor
#    may "VOCAL" appear in their name, without prior written
#    permission of Vovida Networks, Inc.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
# NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
# IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES LOSS OF USE, DATA, OR
# PROFITS OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
# 
# ====================================================================
# 
# This software consists of voluntary contributions made by Vovida
# Networks, Inc. and many individuals on behalf of Vovida Networks,
# Inc.  For more information on Vovida Networks, Inc., please see
# <http://www.vovida.org/>.
#

version="\$Id: make_call_trace.cgi,v 1.1 2000/12/05 22:01:32 icahoon Exp $"

######################################################################
#
#   Load libraries
#
######################################################################

lib_path="${0%/$(basename $0)}"

. $lib_path/vocal_html_lib

log_level=$log_warning

log $log_info "\nVersion: $version\nCommand: $0 $cmd_line"
log $log_info "log level:             $log_level"

######################################################################
#
#   Parse the query string
#
######################################################################

server=""
in_file=""

if [ "$QUERY_STRING" != "" ]
then

log $log_info "QUERY_STRING:          $QUERY_STRING"

    while [ "$QUERY_STRING" != "" ]
    do
    
    	arg=${QUERY_STRING%%&*}
    	arg_name=${arg%%=*}
    	arg_value=${arg#*=}

    	log $log_info "\t$arg_name = $arg_value"

    	QUERY_STRING=${QUERY_STRING#*&}
	
	case $arg_name in
	
    	    server )
	    	server=$arg_value
	    	;;

	    log )
	    	in_file=$arg_value
		QUERY_STRING=""
		;;

    	    * )
	    	QUERY_STRING=""
	    	;;	    	    
	esac
    done
fi

######################################################################
#
#   Miscellaneous variables
#
######################################################################

server_path_prefix="./h323testbed"
log_path_postfix="log/siph323csgw"
output_directory="./siph323csgw"
image_directory="./images"
options="-C"
calltrace_generate="./calltrace_generate"
calltrace_generator="./calltrace_generator.cgi"

file="$server_path_prefix/$server/$log_path_postfix/$in_file"

log $log_info "file: $file"

if [ -r "$file" ]; then
    log $log_info "$calltrace_generate $options $file $output_directory $image_directory"
    $calltrace_generate $options $file $output_directory $image_directory
fi

exec ./calltrace_generator.cgi
