
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const FeatureTrMediaH2S_cxx_Version = 
"$Id: FeatureTrMediaH2S.cxx,v 1.7 2001/10/19 21:37:37 icahoon Exp $";
#include "FeatureTrMediaH2S.hxx"
#include "TrSMCall.hxx"

using namespace translator;


FeatureTrMediaH2S::
FeatureTrMediaH2S(TrSMCall* sm)
    : sm_(sm)
{
    reset();
}


FeatureTrMediaH2S::
~FeatureTrMediaH2S()
{
    // Call exit methods for any state
    setState(&PatternTrMediaH2S::inIdle, "inIdle");
}


void FeatureTrMediaH2S::
reset()
{
    setStateStealth(&PatternTrMediaH2S::inIdle, "inIdle");
}


void FeatureTrMediaH2S::
process_impl(PatternTrMediaH2S& pattern)
{
    (pattern.*(getState()))(*this);
}


#ifndef DISABLE_WRITER

ostream& FeatureTrMediaH2S::
writeTo(ostream& out) const
{
    out << "FeatureTrMediaH2S:"
        << " state=" << getStateName();
    return out;
}


char* FeatureTrMediaH2S::
getStateName() const
{
    if (false)
        return "";
    else if (getState() == &PatternTrMediaH2S::inIdle)
        return "Idle";
    else if (getState() == &PatternTrMediaH2S::inWaitTCS)
        return "WaitTCS";
    else if (getState() == &PatternTrMediaH2S::inWaitSDP)
        return "WaitSDP";
    else if (getState() == &PatternTrMediaH2S::inWaitMsd)
        return "WaitMsd";
    else if (getState() == &PatternTrMediaH2S::inOpening)
        return "Opening";
    else if (getState() == &PatternTrMediaH2S::inComplete)
        return "Complete";
    else if (getState() == &PatternTrMediaH2S::inOther)
        return "Other";
    else
        return "UNKNOWN";
}

#endif
