#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#ifdef __linux__
    #include <getopt.h>
#endif
#include "CommandLine.hxx"
#include "LSSessionManager.hxx"
#include "Daemon.hxx"
#include "cpLog.h"
int
main(int argc, const char** argv)
{
    try
    {

        Sptr < CommandLine > cIn = CommandLine::instance(argc, argv,
                                   "pserver:port altpserver:altport xxxx");

        string pHost = cIn->getString("pshostname");
        int pPort = cIn->getInt("psremoteport");
        cpLog(LOG_DEBUG, "ProvisionServer:%s", pHost.c_str());
        cpLog(LOG_DEBUG, "ProvisionServer port:%d", pPort);

        string altHost = cIn->getString("psbackuphostname");
        int altPort = cIn->getInt("psbackupremoteport");
        cpLog(LOG_DEBUG, "backup ProvisionServer:%s", altHost.c_str());
        cpLog(LOG_DEBUG, "backup ProvisionServer port:%d", altPort);

        //int myPort = cIn->getInt("sipport");

        if (!CommandLine::instance()->getInt("daemon"))
        {
            cpLog(LOG_DEBUG, "Running as daemon");
            Daemon();
        }
        
        LSSessionManager& manager = LSSessionManager::instance(pHost.c_str(), pPort, 
                                                                altHost.c_str(), altPort);
        manager.run();

    }
    catch (VException& e)
    {
        cpLog(LOG_ALERT, "Application exiting, reason: %s", e.getDescription().c_str());
    }
    catch (...)
    {
        cpLog(LOG_ALERT, "Application exiting, reason:Unknown");
    }

        
}
